Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 858)
@@ -18,4 +18,6 @@
    USE sms
    USE p4zsink2        !
+   USE prtctl_trc
+
 
    IMPLICIT NONE
@@ -46,4 +48,5 @@
       INTEGER  ::   iksed
       REAL(wp) ::   zagg1, zagg2, zagg3, zagg4
+      REAL(wp) ::   zagg , zaggfe, zaggdoc, zaggdoc2
       REAL(wp) ::   zfact, zstep, zwsmax
 #if defined key_trc_dia3d
@@ -53,4 +56,5 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zsinkfer, zsinkfer2
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zsinkcal, zsinksil
+      CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
@@ -120,5 +124,5 @@
             DO ji = 1, jpi
 
-               zfact = zstep * zdiss(ji,jj,jk)
+               zfact = zstep * xdiss(ji,jj,jk)
 
 !    Part I : Coagulation dependent on turbulence
@@ -155,21 +159,27 @@
 # endif
 
-               xagg  (ji,jj,jk) = zagg1 + zagg2 + zagg3 + zagg4
-               xaggfe(ji,jj,jk) = xagg(ji,jj,jk) * trn(ji,jj,jk,jpsfe) / ( trn(ji,jj,jk,jppoc) + rtrn )
+               zagg   = zagg1 + zagg2 + zagg3 + zagg4
+               zaggfe = zagg * trn(ji,jj,jk,jpsfe) / ( trn(ji,jj,jk,jppoc) + rtrn )
 
 !     Aggregation of DOC to small particles
 !     --------------------------------------
 
-               xaggdoc(ji,jj,jk) = ( 80.* trn(ji,jj,jk,jpdoc) + 698. * trn(ji,jj,jk,jppoc) )       &
-# if defined key_off_degrad
-                  &              * facvol(ji,jj,jk)                           &
-# endif
-                  &              * zfact * trn(ji,jj,jk,jpdoc)
-
-               xaggdoc2(ji,jj,jk) = 1.05e4 * zfact * trn(ji,jj,jk,jpgoc)   &
-# if defined key_off_degrad
-                  &               * facvol(ji,jj,jk)                            &
+               zaggdoc = ( 80.* trn(ji,jj,jk,jpdoc) + 698. * trn(ji,jj,jk,jppoc) )       &
+# if defined key_off_degrad
+                  &      * facvol(ji,jj,jk)                           &
+# endif
+                  &      * zfact * trn(ji,jj,jk,jpdoc)
+
+               zaggdoc2 = 1.05e4 * zfact * trn(ji,jj,jk,jpgoc)   &
+# if defined key_off_degrad
+                  &        * facvol(ji,jj,jk)                            &
 # endif      
-                  &               * trn(ji,jj,jk,jpdoc)
+                  &        * trn(ji,jj,jk,jpdoc)
+
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zagg + zaggdoc
+               tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zagg + zaggdoc2
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zaggfe
+               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zaggfe
+               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) - zaggdoc - zaggdoc2
 
             END DO
@@ -187,4 +197,10 @@
 # endif
       !
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('sink')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
+
    END SUBROUTINE p4z_sink
 
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink2.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink2.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink2.F90	(revision 858)
@@ -47,11 +47,11 @@
       REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   sinktemp   ! ???
       !!
-      INTEGER  ::   ji, jj, jk
+      INTEGER  ::   ji, jj, jk, jnt
       REAL(wp) ::   zigma,zew,zstep,zign
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztraz, zakz
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zkz  , wstmp2
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zkz  , zwstmp2
       !!---------------------------------------------------------------------
 
-      zstep  = rfact2
+      zstep  = rfact2 / 2.
 
       ztraz(:,:,:) = 0.e0
@@ -61,70 +61,92 @@
       DO jk = 1, jpkm1
 # if defined key_off_degrad
-         wstmp2(:,:,jk+1)=-wstmp(:,:,jk)/rjjss*tmask(:,:,jk+1)*facvol(:,:,jk)
+         zwstmp2(:,:,jk+1)=-wstmp(:,:,jk)/rjjss*tmask(:,:,jk+1)*facvol(:,:,jk)
 # else
-         wstmp2(:,:,jk+1)=-wstmp(:,:,jk)/rjjss*tmask(:,:,jk+1)
+         zwstmp2(:,:,jk+1)=-wstmp(:,:,jk)/rjjss*tmask(:,:,jk+1)
 
 # endif
       END DO
  
-      wstmp2(:,:,1) = 0.e0
+      zwstmp2(:,:,1) = 0.e0
 !
 ! Vertical advective flux
 !-------------------------------
-! ... first guess of the slopes
-!   ... interior values
-      DO jk = 2, jpkm1
-         ztraz(:,:,jk) = (trn(:,:,jk-1,jn) - trn(:,:,jk,jn)) *tmask(:,:,jk)
-      END DO
+
+      DO jnt = 1, 2
+
+! ... first guess of the slopes interior values
+
+         DO jk = 2, jpkm1
+            ztraz(:,:,jk) = (trn(:,:,jk-1,jn) - trn(:,:,jk,jn)) *tmask(:,:,jk)
+         END DO
+
+         ztraz(:,:,1  ) = 0.0
+         ztraz(:,:,jpk) = 0.0
 !
 ! slopes
-      DO jk=2,jpkm1
-         DO jj = 1,jpj
-            DO ji = 1, jpi
-               zign = 0.5*(sign(1.,ztraz(ji,jj,jk)*ztraz(ji,jj,jk+1))+1)
-               zakz(ji,jj,jk) = 0.5*(ztraz(ji,jj,jk) + ztraz(ji,jj,jk+1) ) * zign
-            END DO
-          END DO
-        END DO        
-!
-! Slopes limitation
-      DO jk = 2, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zakz(ji,jj,jk) = sign(1.,zakz(ji,jj,jk)) *        &
-                  &             min(abs(zakz(ji,jj,jk)),         &
-                  &             2.*abs(ztraz(ji,jj,jk+1)),       &
-                  &             2.*abs(ztraz(ji,jj,jk)))
+         DO jk=2,jpkm1
+            DO jj = 1,jpj
+               DO ji = 1, jpi
+                  zign = 0.25 + SIGN( 0.25,ztraz(ji,jj,jk)*ztraz(ji,jj,jk+1) )
+                  zakz(ji,jj,jk) = (ztraz(ji,jj,jk) + ztraz(ji,jj,jk+1) ) * zign
+               END DO
             END DO
          END DO
-      END DO        
-
-! vertical advective flux
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj      
-            DO ji = 1, jpi    
-               zigma = wstmp2(ji,jj,jk+1)*zstep/fse3w(ji,jj,jk+1)
-               zew   = wstmp2(ji,jj,jk+1)
-               sinktemp(ji,jj,jk+1) = -zew*(trn(ji,jj,jk,jn)                &
-                  &                 -0.5*(1+zigma)*zakz(ji,jj,jk))*zstep
+         !
+         ! Slopes limitation
+         DO jk = 2, jpkm1
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zakz(ji,jj,jk) = SIGN(1.,zakz(ji,jj,jk)) *        &
+                     &             MIN(ABS(zakz(ji,jj,jk)),         &
+                     &             2.*ABS(ztraz(ji,jj,jk+1)),       &
+                     &             2.*ABS(ztraz(ji,jj,jk)))
+               END DO
             END DO
          END DO
-      END DO 
-!
-! Boundary conditions
-      sinktemp(:,:,1  ) = 0.e0
-      sinktemp(:,:,jpk) = 0.e0
+         
+         ! vertical advective flux
+         DO jk = 1, jpkm1
+            DO jj = 1, jpj      
+               DO ji = 1, jpi    
+                  zigma = zwstmp2(ji,jj,jk+1)*zstep/fse3w(ji,jj,jk+1)
+                  zew   = zwstmp2(ji,jj,jk+1)
+                  sinktemp(ji,jj,jk+1) = -zew*(trn(ji,jj,jk,jn)                &
+                     &                 -0.5*(1+zigma)*zakz(ji,jj,jk))*zstep
+               END DO
+            END DO
+         END DO
+         !
+         ! Boundary conditions
+         sinktemp(:,:,1  ) = 0.e0
+         sinktemp(:,:,jpk) = 0.e0
+         
+         DO jk=1,jpkm1
+            DO jj = 1,jpj
+               DO ji = 1, jpi
+                  trn(ji,jj,jk,jn) = trn(ji,jj,jk,jn)               &
+                     &        + (sinktemp(ji,jj,jk)-sinktemp(ji,jj,jk+1))     &
+                     &        /fse3t(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+
+      ENDDO
 
       DO jk=1,jpkm1
          DO jj = 1,jpj
             DO ji = 1, jpi
-               trn(ji,jj,jk,jn) = trn(ji,jj,jk,jn)               &
-                  &        + (sinktemp(ji,jj,jk)-sinktemp(ji,jj,jk+1))     &
-                  &        /fse3t(ji,jj,jk)
-            END DO
-         END DO
-      END DO
+               ! 
+               trb(ji,jj,jk,jn) = trb(ji,jj,jk,jn)      &
+               &        + 2.*(sinktemp(ji,jj,jk)-sinktemp(ji,jj,jk+1)) &
+               &        /fse3t(ji,jj,jk)
+!
+          ENDDO
+        ENDDO
+      ENDDO
+!
+        trn(:,:,:,jn)   = trb(:,:,:,jn)
+        sinktemp(:,:,:) = 2. * sinktemp(:,:,:)
 
-      trb(:,:,:,jn) = trn(:,:,:,jn)
       !
    END SUBROUTINE p4z_sink2
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink_kriest.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink_kriest.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/p4zsink_kriest.F90	(revision 858)
@@ -20,4 +20,5 @@
    USE sms
    USE p4zsink2
+   USE prtctl_trc
 
    IMPLICIT NONE
@@ -45,11 +46,12 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jk
-      INTEGER  ::   iksed
-      REAL(wp) ::   zagg1, zagg2, zagg3, zagg4, zagg5, zaggsi, zaggsh
-      REAL(wp) ::   znum , zeps, zfm, zgm, zsm
-      REAL(wp) ::   zdiv , zdiv1, zdiv2, zdiv3, zdiv4, zdiv5
-      REAL(wp) ::   zval1, zval2, zval3, zval4
-      REAL(wp) ::   zstep
+      INTEGER  :: ji, jj, jk
+      INTEGER  :: iksed
+      REAL(wp) :: zagg1, zagg2, zagg3, zagg4, zagg5, zaggsi, zaggsh
+      REAL(wp) :: zagg , zaggdoc, znumdoc
+      REAL(wp) :: znum , zeps, zfm, zgm, zsm
+      REAL(wp) :: zdiv , zdiv1, zdiv2, zdiv3, zdiv4, zdiv5
+      REAL(wp) :: zval1, zval2, zval3, zval4
+      REAL(wp) :: zstep
 #if defined key_trc_dia3d
       REAL(wp) ::   zrfact2
@@ -59,4 +61,6 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   sinkfer
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   sinkcal, sinksil
+      CHARACTER (len=25) :: charout
+
       !!---------------------------------------------------------------------
 
@@ -184,5 +188,5 @@
                      &    )
 
-                  zaggsh = ( zagg1 + zagg2 + zagg3 ) * rfact2 * zdiss(ji,jj,jk) / 1000.
+                  zaggsh = ( zagg1 + zagg2 + zagg3 ) * rfact2 * xdiss(ji,jj,jk) / 1000.
 
 !    Aggregation of small into large particles
@@ -213,15 +217,20 @@
                   zaggsi = ( zagg4 + zagg5 ) * zstep / 10.
 
-                  xagg(ji,jj,jk) = 0.5 * xkr_stick * ( zaggsh + zaggsi )
+                  zagg = 0.5 * xkr_stick * ( zaggsh + zaggsi )
 
 !     Aggregation of DOC to small particles
 !     --------------------------------------
 
-                  xaggdoc(ji,jj,jk) = (     0.4 * trn(ji,jj,jk,jpdoc)               &
-                     &                 + 1018.  * trn(ji,jj,jk,jppoc)  ) * zstep    &
-# if defined key_off_degrad
-                     &              * facvol(ji,jj,jk)                              &
-# endif
-                     &              * zdiss(ji,jj,jk) * trn(ji,jj,jk,jpdoc)
+                  zaggdoc = ( 0.4 * trn(ji,jj,jk,jpdoc)               &
+                     &        + 1018.  * trn(ji,jj,jk,jppoc)  ) * zstep    &
+# if defined key_off_degrad
+                     &        * facvol(ji,jj,jk)                              &
+# endif
+                     &        * xdiss(ji,jj,jk) * trn(ji,jj,jk,jpdoc)
+                      
+                  znumdoc = trn(ji,jj,jk,jpnum) / ( trn(ji,jj,jk,jppoc) + rtrn )
+                  tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zaggdoc
+                  tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) + zaggdoc * znumdoc - zagg
+                  tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) - zaggdoc
 
                ENDIF
@@ -246,4 +255,9 @@
 #    endif
       !
+       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('sink')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+       ENDIF
    END SUBROUTINE p4z_sink_kriest
 
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/sms_pisces.h90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/sms_pisces.h90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/sms_pisces.h90	(revision 858)
@@ -15,30 +15,15 @@
    !! Variable for chemistry of the CO2 cycle
    !! ---------------------------------------------------------------------
-   REAL(wp) ::   atcco2, atcox
+   REAL(wp) ::   atcco2
    !
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   akb3, ak13, ak23, aksp, akw3             !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   akp13, akp23, akp33, aksi3, aks3, akf3   !: ???
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   hi, borat                                !: ???
+   REAL, DIMENSION(2) :: qcumul
 
    !!----------------------------------------------------------------------
    !!  Variable for chemistry of the CO2 cycle
    !! ---------------------------------------------------------------------
-   REAL(wp), DIMENSION(10) ::   devk1, devk2, devk3, devk4, devk5     
    !
-   REAL(wp) ::   akcc1, akcc2, akcc3, akcc4,akcc5, akcc6, akcc7, akcc8, akcc9     !: ???
-   REAL(wp) ::   bor1, bor2, c00, c01, c02, c03, c04, c05, c10, c11               !: ???
-   REAL(wp) ::   c12, c13, c20, c21, c22, c23, cb0, cb1, cb2, cb3                 !: ???
-   REAL(wp) ::   cb4, cb5, cb6, cb7, cb8, cb9, cb10, cb11, c14                    !: ???
-   REAL(wp) ::   cw3, cw4, cw5, cw6, cw0, cw1, cw2, ox0, ox1, ox2, ox3, ox4,ox5   !: ???
-   REAL(wp) ::   salchl, rgas, oxyco, ca0, ca1, ca2, ca3, ca4, ca5, ca6           !: ???
-   REAL(wp) ::   cp10, cp11, cp12, cp13, cp14, cp15, cp16, cp20, cp21             !: ???
-   REAL(wp) ::   cp22, cp23, cp24, cp25, cp26, cp30, cp31, cp32, cp33             !: ???
-   REAL(wp) ::   cp34, cp35, cs10, cs11, cs12, cs13, cs14, cs15, cs16             !: ???
-   REAL(wp) ::   cs17, cs18, cs19, cs20, cs21                                     !: ???
-   REAL(wp) ::   st1, st2, ft1, ft2, ks0, ks1, ks2, ks3, ks4, ks5                 !: ???
-   REAL(wp) ::   ks6, ks7, ks8, ks9, ks10, ks11, ks12, kf0, kf1                   !: ???
-   REAL(wp) ::   kf2, kf3, kf4
-   !
-   REAL(wp), DIMENSION(jpi,jpj,3) ::   chemc   !: ???
+   REAL(wp), DIMENSION(jpi,jpj,2) ::   chemc   !: ???
 
    !!----------------------------------------------------------------------
@@ -68,5 +53,5 @@
    REAL(wp) ::   caco3r, kdca, nca, part, rno3, o2ut, po4r               !: ???
    REAL(wp) ::   sco2, dispo0, conc0,sumdepsi,rivalkinput,sedfeinput     !: ???
-   REAL(wp) ::   calcon, rivpo4input,nitdepinput,oxymin,spocri           !: ???
+   REAL(wp) ::   rivpo4input,nitdepinput,oxymin,spocri           !: ???
    REAL(wp) ::   nitrif,rdenit,o2nit,concnnh4,concdnh4                   !: ???
    REAL(wp) ::   pislope,excret,wsbio,resrat,mprat,wchl,wchld            !: ???
@@ -83,6 +68,7 @@
    !!---------------------------------------------
    REAL(wp), DIMENSION(3,61)        ::   xkrgb                 !: ???
-   REAL(wp), DIMENSION(jpi,jpj)     ::   zmeu                  !: ???
+   REAL(wp), DIMENSION(jpi,jpj)     ::   heup                  !: ???
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   etot, etot3, emoy     !: ???
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   enano, ediat
 
 !!----------------------------------------------------------
@@ -92,28 +78,6 @@
    !
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   prmax, tgfunc, tgfunc2                       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   prcaca, prorca, prorca2, prorca3             !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   prorca4, prorca5, prorca6, prorca7           !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   pronew, pronew2, proreg, proreg2             !: ???
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xnanono3, xdiatno3, xnanonh4, xdiatnh4       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimphy, xlimdia, concdfe, concnfe, znegtr   !: ???
-
-   !!------------------------------------------
-   !! Sinks for phytoplankton
-   !!------------------------------------------
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   tortp, tortnf, tortnch            !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   respp, respp2, respnch, respdch   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   tortp2, tortdf, tortdch, tortds   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   respds, respdf, respnf            !: ???
-
-   !!------------------------------------
-   !!  SMS for zooplankton
-   !!-------------------------------------
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   respz, tortz, grazp, grazpf                   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grazpch, grazm, grazmf, grazsd                !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grazsf, grazss, grazsch, grarem               !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grafer,respz2,tortz2,grazd, grazz,grazn       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grazpoc,graznf, graznch, grazs, grazf         !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grazdch, grazpof, grarem2, grafer2, grapoc2   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grapoc, grazffe, grazfff                      !: ???
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimphy, xlimdia, concdfe, concnfe, xnegtr   !: ???
 
    !!---------------------------------------------
@@ -122,7 +86,5 @@
    REAL(wp) ::   wsbio2
    !
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xagg, xaggfe, zdiss, xaggdoc, xaggdfe, xbactfer   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xscave, olimi, orem, orem2, ofer, ofer2           !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   osil, xaggdoc2, nitrfac, xlimbac                  !: ???
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiss, xfracal, nitrfac, xlimbac                  !: ???
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   wsbio4, wsbio3, wscal                             !: ???
 
@@ -136,5 +98,5 @@
    REAL(wp), DIMENSION(jpi,jpj)     ::   dust, cotdep, nitdep, rivinp   !: ???
    REAL(wp), DIMENSION(jpi,jpj,12)  ::   dustmo                         !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   onitr, denitr, ironsed         !: ???
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   denitr, ironsed         !: ???
 
 #if defined key_kriest
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/trcctl.pisces.h90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/trcctl.pisces.h90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/trcctl.pisces.h90	(revision 858)
@@ -18,7 +18,7 @@
    ! -----------------------
 #if  defined key_kriest
-      IF( jptra /= 23) THEN 
+      IF( jp_pisces /= 23) THEN 
 #else
-      IF( jptra /= 24) THEN
+      IF( jp_pisces /= 24) THEN
 #endif
           IF (lwp) THEN 
@@ -26,5 +26,5 @@
               WRITE (numout,*) ' =======   ============= '
               WRITE (numout,*)                               &
-              &   ' STOP, change jptra',               & 
+              &   ' STOP, change jp_pisces',               & 
               &   ' in parameter.passivetrc.pisces.h '  
           END IF 
Index: branches/dev_001_GM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- branches/dev_001_GM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 857)
+++ branches/dev_001_GM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 858)
@@ -21,4 +21,6 @@
    USE oce_trc         ! ocean variables
    USE trp_trc         !
+   USE p4zche 
+   USE lbclnk
 
    USE iom
@@ -28,4 +30,5 @@
 
    PUBLIC   trc_ini_pisces   ! called by trcini.F90 module
+
 
 #  include "domzgr_substitute.h90"
@@ -295,252 +298,4 @@
       o2ut   = 140.     / 122.
 
-      !----------------------------------------------------------------------
-      ! Initialize chemical variables 
-      !----------------------------------------------------------------------
-
-      ! set pre-industrial atmospheric [co2] (ppm) and o2/n2 ratio
-      ! ----------------------------------------------------------
-      atcox = 0.20946
-
-      ! Set lower/upper limits for temperature and salinity
-      ! ---------------------------------------------------
-      salchl = 1.e0 / 1.80655
-      calcon = 1.03e-2
-
-      ! Set coefficients for apparent solubility equilibrium of calcite
-      ! Millero et al. 1995 from Mucci 1983
-      ! --------------------------------------------------------------
-      akcc1 = -171.9065
-      akcc2 =   -0.077993
-      akcc3 = 2839.319
-      akcc4 =   71.595
-      akcc5 =   -0.77712
-      akcc6 =    0.0028426
-      akcc7 =  178.34
-      akcc8 =   -0.07711
-      akcc9 =    0.0041249
-
-      ! Set coefficients for seawater pressure correction
-      ! -------------------------------------------------
-      devk1(1) = -25.5
-      devk2(1) =   0.1271
-      devk3(1) =   0.e0
-      devk4(1) =  -3.08E-3
-      devk5(1) =   0.0877E-3
-      !
-      devk1(2) = -15.82
-      devk2(2) =  -0.0219
-      devk3(2) =   0.e0
-      devk4(2) =   1.13E-3
-      devk5(2) =  -0.1475E-3
-      !
-      devk1(3) = -29.48
-      devk2(3) =   0.1622
-      devk3(3) =   2.608E-3
-      devk4(3) =  -2.84E-3
-      devk5(3) =   0.e0
-      !
-      devk1(4) = -14.51
-      devk2(4) =   0.1211
-      devk3(4) =  -0.321E-3
-      devk4(4) =  -2.67E-3
-      devk5(4) =   0.0427E-3
-      !
-      devk1(5) = -23.12
-      devk2(5) =   0.1758
-      devk3(5) =  -2.647E-3
-      devk4(5) =  -5.15E-3
-      devk5(5) =   0.09E-3
-      !
-      devk1(6) = -26.57
-      devk2(6) =   0.2020
-      devk3(6) =  -3.042E-3
-      devk4(6) =  -4.08E-3
-      devk5(6) =   0.0714E-3
-      !
-      devk1(7) = -25.60
-      devk2(7) =   0.2324
-      devk3(7) =  -3.6246E-3
-      devk4(7) =  -5.13E-3
-      devk5(7) =   0.0794E-3
-      !
-      ! For calcite with Edmond and Gieske 1970
-      !     devkst = 0.23
-      !     devks  = 35.4
-      ! Millero 95 takes this depth dependance for calcite
-      devk1(8) = -48.76
-      devk2(8) =   0.5304
-      devk3(8) =   0.e0
-      devk4(8) = -11.76E-3
-      devk5(8) =   0.3692E-3
-      !
-      ! Coefficients for sulfate and fluoride
-      devk1(9) = -18.03
-      devk2(9) =   0.0466
-      devk3(9) =   0.316e-3
-      devk4(9) =  -4.53e-3
-      devk5(9) =   0.09e-3
-
-      devk1(10) = -9.78
-      devk2(10) = -0.0090
-      devk3(10) = -0.942e-3
-      devk4(10) = -3.91e-3
-      devk5(10) =  0.054e-3
-
-
-      ! Set universal gas constants
-      ! ---------------------------
-      rgas  = 83.143
-      oxyco =  1.e0 / 22.4144
-
-      ! Set boron constants
-      ! -------------------
-      bor1 = 0.00023
-      bor2 = 1.e0 / 10.82
-
-      ! Set volumetric solubility constants for co2 in ml/l (Weiss, 1974)
-      ! -----------------------------------------------------------------
-      c00 = -60.2409
-      c01 =  93.4517
-      c02 =  23.3585
-      c03 =   0.023517
-      c04 =  -0.023656
-      c05 =   0.0047036
-      !
-      ca0 = -162.8301
-      ca1 =  218.2968
-      ca2 =   90.9241
-      ca3 =   -1.47696
-      ca4 =    0.025695
-      ca5 =   -0.025225
-      ca6 =    0.0049867
-
-      ! Set coeff. for 1. dissoc. of carbonic acid (Edmond and Gieskes, 1970)
-      ! ---------------------------------------------------------------------
-      c10 = -3670.7
-      c11 =    62.008
-      c12 =    -9.7944
-      c13 =     0.0118
-      c14 =    -0.000116
-
-      ! Set coeff. for 2. dissoc. of carbonic acid (Edmond and Gieskes, 1970)
-      ! ---------------------------------------------------------------------
-      c20 = -1394.7
-      c21 =    -4.777
-      c22 =     0.0184
-      c23 =    -0.000118
-
-      ! Set constants for calculate concentrations for sulfate and fluoride
-      ! sulfates (Morris & Riley 1966)
-      !----------------------------------------------------------------------
-      st1 = 0.14
-      st2 = 1.e0 / 96.062
-
-      ! fluoride
-      ! --------
-      ft1 = 0.000067
-      ft2 = 1.e0 / 18.9984
-
-      ! sulfates (Dickson 1990 change to mol:kg soln, idem OCMIP)
-      !----------------------------------------------------------
-      ks0  =    141.328
-      ks1  =  -4276.1
-      ks2  =    -23.093
-      ks3  = -13856.
-      ks4  =    324.57
-      ks5  =    -47.986
-      ks6  =  35474.
-      ks7  =   -771.54
-      ks8  =    114.723
-      ks9  =  -2698.
-      ks10 =   1776.
-      ks11 =      1.
-      ks12 =     -0.001005
-
-      ! fluorides (Dickson & Riley 1979 change to mol/kg soln)
-      !-------------------------------------------------------
-      kf0 =  -12.641
-      kf1 = 1590.2
-      kf2 =    1.525
-      kf3 =    1.0
-      kf4 =   -0.001005
-
-      ! Set coeff. for 1. dissoc. of boric acid (Edmond and Gieskes, 1970)
-      ! ------------------------------------------------------------------
-      cb0  = -8966.90
-      cb1  = -2890.53
-      cb2  =   -77.942
-      cb3  =     1.728
-      cb4  =    -0.0996
-      cb5  =   148.0248
-      cb6  =   137.1942
-      cb7  =     1.62142
-      cb8  =   -24.4344
-      cb9  =   -25.085
-      cb10 =    -0.2474
-      cb11 =     0.053105
-
-      ! Set coeff. for dissoc. of water (Dickson and Riley, 1979, 
-      !   eq. 7, coefficient cw2 corrected from 0.9415 to 0.09415 
-      !   after pers. commun. to B. Bacastow, 1988)
-      ! ---------------------------------------------------------
-      cw0 = -13847.26
-      cw1 =    148.9652
-      cw2 =    -23.6521
-      cw3 =    118.67
-      cw4 =     -5.977
-      cw5 =      1.0495
-      cw6 =     -0.01615
-
-      ! Set coeff. for dissoc. of phosphate (Millero (1974)
-      ! ---------------------------------------------------
-      cp10 =   115.54
-      cp11 = -4576.752
-      cp12 =   -18.453
-      cp13 =  -106.736
-      cp14 =     0.69171
-      cp15 =    -0.65643
-      cp16 =    -0.01844
-      !
-      cp20 =   172.1033
-      cp21 = -8814.715
-      cp22 =   -27.927
-      cp23 =  -160.340
-      cp24 =     1.3566
-      cp25 =     0.37335
-      cp26 =    -0.05778
-      !
-      cp30 =   -18.126
-      cp31 = -3070.75
-      cp32 =    17.27039
-      cp33 =     2.81197
-      cp34 =   -44.99486
-      cp35 =    -0.09984
-
-      ! Set coeff. for dissoc. of phosphate (Millero (1974)
-      ! ---------------------------------------------------
-      cs10 =   117.385
-      cs11 = -8904.2
-      cs12 =   -19.334
-      cs13 =  -458.79
-      cs14 =     3.5913
-      cs15 =   188.74
-      cs16 =    -1.5998
-      cs17 =   -12.1652
-      cs18 =     0.07871
-      cs19 =     0.e0
-      cs20 =     1.e0
-      cs21 =    -0.001005
-
-
-      ! Set volumetric solubility constants for o2 in ml/l (Weiss, 1970)
-      ! ----------------------------------------------------------------
-      ox0 = -58.3877
-      ox1 =  85.8079
-      ox2 =  23.8439
-      ox3 =  -0.034892
-      ox4 =   0.015568
-      ox5 =  -0.0019387
-
       !  FROM THE NEW BIOOPTIC MODEL PROPOSED JM ANDRE, WE READ HERE
       !  A PRECOMPUTED ARRAY CORRESPONDING TO THE ATTENUATION COEFFICIENT
@@ -554,5 +309,5 @@
 
 
-      CALL p4zche        ! initialize the chemical constants
+      CALL p4z_che        ! initialize the chemical constants
 
 
